/******************************************************************************
    CallWave SMS Widget

    Copyright (C) 2006 CallWave, Inc.  All Rights Reserved.

 ******************************************************************************/

var VM_WIDGET_SOURCE     = 'SX'; // do not change these variable names. They are used in lower level shared code
var VM_WIDGET_VERSION    = '3.7';
var VM_WIDGET_OS_VERSION = '';

var CLIENT_VERSION_CHECK_URL = "http://www.callwave.com/sms/checkForUpdates.html";
var HELP_URL                 = "http://www.callwave.com/sms/mainfaq.asp";

var CONTACT_NONE_SELECTED_VALUE = "---none---";

function VM_GetPreference( key )
{
    if ( window.widget )
    {
        var value = widget.preferenceForKey( key );
        return ( value === undefined ? null : value );
    }

    if ( typeof __widgetArr == "undefined" )
    {
        __widgetArr = new Array( );
    }

    var value = __widgetArr[ key ];
    return ( value === undefined ? null : value );
}

function VM_SetPreference( key, value )
{
    if ( window.widget )
    {
        widget.setPreferenceForKey( value, key );
    }
    else
    {
        if ( typeof __widgetArr == "undefined" )
        {
            __widgetArr = new Array( );
        }

        __widgetArr[ key ] = value;
    }
}

function EX_Log( message )
{
    alert( message );
}

function OnCountryChanged( countryPopup )
{
    try
    {
        var countryCode = SMS_UTILS_GetSelectedValueFromPopup( countryPopup );

        if ( countryCode == -1 )
        {
            countryPopup.options[ 0 ].selected = true;

            document.getElementById( countryPopup.countryCodeDisplay ).innerHTML = '';

            return;
        }

        document.getElementById( countryPopup.countryCodeDisplay ).innerHTML = countryCode;
    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, 'SMS.js::OnCountryChanged( )' );
    }
}

function MigrateSettings( )
{
    try
    {
        var downRevSenderMobile = VM_GetPreference( PREF_KEY_DOWNREV_SENDER_MOBILE );

        if ( downRevSenderMobile === null ||
             typeof downRevSenderMobile == 'undefined' ||
             downRevSenderMobile.length == 0 )
        {
            return;
        }

        VM_SetPreference( PREF_KEY_DOWNREV_SENDER_MOBILE, '' );

        var senderMobile = VM_GetPreference( PREF_KEY_SENDER_MOBILE );

        if ( senderMobile )
        {
            return;
        }

        senderMobile = new SMS_MobileNumberControlPersistentState( CMD_COUNTRY_CODE_CONTROL_ID, '', downRevSenderMobile );

        VM_SetPreference( PREF_KEY_SENDER_MOBILE, senderMobile.AsString( ) );
    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, "SMS.js::MigrateSettings( )" );
    }
}

function Setup( )
{
    try
    {
        VM_WIDGET_OS_VERSION = navigator.platform;

        MigrateSettings( );

        VM_URL.set_targetService( 'sms' );
        VM_URL._updateUrls( );

        InitializeSMSData( );

        SMS_widgetViewController = new SMS_WidgetViewController( OnAccountInformationChanged );
    }
    catch ( e )
    {
        EX_Log( "SMS.js::Setup( )\n" + e.message );
    }
}

function OpenURL( url, queryParameterHash )
{
    try
    {
        var queryParameters = '';

        var param = null;
        for ( param in queryParameterHash )
        {
            queryParameters += '&' + param + '=' + queryParameterHash[ param ];
        }

        if ( queryParameters.length != 0 )
        {
            // append the parameters to the URL, skipping the first
            // character of queryParameters since it's an ampersand.
            url += '?' + queryParameters.substr( 1 );
        }

        window.widget ? widget.openURL( url ) : window.open( url, '' );
    }
    catch ( e )
    {
        EX_Log( "SMS.js::OpenURL( )\n" + e.message );
    }
}

function OpenWidgetURL( url, queryParameterHash )
{
    var queryParameters =
    {
        src : VM_WIDGET_SOURCE,
        ver : VM_WIDGET_VERSION,
        os  : VM_WIDGET_OS_VERSION
    };

    EXT_extend( queryParameters, queryParameterHash )

    OpenURL( url, queryParameters );
}

function OpenWidgetURLWithUString( url )
{
    var queryParameters = { };

    var uString = VM_GetPreference( PREF_KEY_U_STRING );

    if ( uString != null && uString.length != 0 )
    {
        queryParameters.u = uString;
    }

    OpenWidgetURL( url, queryParameters );
}

function InitializeSMSData( )
{
    try
    {
        FillContactsPopup( );

        InitializeBackPane( );

        // populate the popups
        SMS_PopulateCarrierNames( document.getElementById( 'carrierPopup' ),       SMS_GetRecipientCarrierList( ) );
        SMS_PopulateCarrierNames( document.getElementById( 'WIDGET_wirelessProviderPopup' ), SMS_GetSenderCarrierList( ) );
    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, "SMS.js::InitializeSMSData( )" );
    }
}

/******************************************************************************
  FillContactsPopup

    Populates the contacts popup from the address book

******************************************************************************/
function FillContactsPopup( )
{
    try
    {
        var contactPopup = document.getElementById( "contactPopup" );

        // Remove all the existing providers
        while ( contactPopup.length != 0 )
        {
            contactPopup.remove( 0 );
        }

        contactPopup.options[ 0 ] = new Option( "Name", CONTACT_NONE_SELECTED_VALUE );

        if ( typeof SmsPlugin == 'undefined' )
        {
            return;
        }

        var numContacts = SmsPlugin.numEntries( );
        for ( var i = 0; i < numContacts; i++ )
        {
            contactPopup.options[ i + 1 ] = new Option( SmsPlugin.nameAtIndex( i ), SmsPlugin.mobileNumberAtIndex( i ) );
        }
    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, "SMS.js::FillContactsPopup( )" );
    }
}

function InitializeBackPane( )
{
    try
    {
        if ( typeof createGenericButton == 'undefined' )
        {
            __createGenericButton_Funcs = new Array( );
            createGenericButton = function( targetDiv, value, callback, width )
            {
                __createGenericButton_Funcs[ __createGenericButton_Funcs.length ] = callback;
                targetDiv.innerHTML = '<input type=button value="' + value + '" ' +
                                      'onClick="__createGenericButton_Funcs[ '+ ( __createGenericButton_Funcs.length - 1 ) + ' ]( );" ' +
                                      'size="'+ width + '" />';
            };
        }

        // create buttons
        var versionCheckButton = document.getElementById( 'versionCheckButton' );
        createGenericButton( versionCheckButton, 'Check for updates', OnCheckForUpdates, 87 );

        var logoutButton = document.getElementById( 'logoutButton' );
        createGenericButton( logoutButton, 'Logout', OnLogout, 50 );

        var reloadButton = document.getElementById( 'reloadButton' );
        createGenericButton( reloadButton, 'Reload Contacts', OnReloadContacts, 67 );

        var doneButton = document.getElementById( 'doneButton' );
        createGenericButton( doneButton, 'Done', OnBackPaneDoneButton, 50 );

    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, "SMS.js::InitializeBackPane( )" );
    }
}

function OnAccountInformationChanged( name, emailAddress, phoneNumber )
{
    try
    {
        var userInformation = '';

        if ( phoneNumber )
        {
            userInformation +=
              tag('tr','',
                tag('td', {'class':'heading', 'align': 'right'}, "Mobile Number:") +
                tag('td', {'class':'userInformation', 'valign': 'middle'}, phoneNumber.replace(/^(\d{3})(\d{3})(\d{4})$/, "$1-$2-$3" ) )); // mobile phone number (10 digits)
        }

        if ( name )
        {
            userInformation +=
              tag('tr','',
                tag('td', {'class':'heading', 'align': 'right'}, "Name:") +
                tag('td', {'class':'userInformation', 'valign': 'middle'}, name ));
        }

        if ( emailAddress )
        {
            userInformation +=
              tag('tr','',
                tag('td', {'class':'heading', 'align': 'right'}, "Email:") +
                tag('td', {'class':'userInformation', 'valign': 'middle'}, emailAddress ));
        }

        if ( userInformation.length )
        {
            document.getElementById( 'WIDGET_personalInfo' ).innerHTML =
              tag('table', {width:'100%'}, userInformation );
        }
    }
    catch ( e )
    {
        EX_ASSERT_NO_EXCEPTIONS( e, 'SMS.js::OnAccountInformationChanged( )' );
    }
}

/******************************************************************************
  OnReloadContacts

    Handler for contact reloading button

******************************************************************************/
function OnReloadContacts( )
{
    try
    {
        if ( SmsPlugin )
        {
            SmsPlugin.loadContactsFromAddressBook( );

            FillContactsPopup( );

            // reset the selection by setting the
            SMS_widgetViewController.GetSMSView( ).SynchronizeContactSelectionToNumber( );
            SMS_widgetViewController.GetSMSView( ).OnContactChanged( );
        }
        else
        {
            EX_Log( "SmsPlugin not loaded." );
        }
    }
    catch ( e )
    {
        EX_Log( "SMS.js::OnReloadContacts( )\n" + e.message );
    }
}


/******************************************************************************
  OnShowBack

    Handler for transitioning to back pane

******************************************************************************/
function OnShowBack( )
{
    var front = document.getElementById( "WIDGET_smsViewFrame" );
    var back = document.getElementById( "WIDGET_backViewFrame" );

    if ( window.widget )
    {
        widget.prepareForTransition( "ToBack" );
    }

    front.style.display = 'none';
    back.style.display = 'block';

    if ( window.widget )
    {
        setTimeout( 'widget.performTransition( );', 0 );
    }
}

/******************************************************************************
  OnSenderCarrierChanged

    Handles sender carrier selection-change events

******************************************************************************/
function OnSenderCarrierChanged( )
{
    var chosenCarrierId = SMS_UTILS_GetSelectedValueFromPopup( document.getElementById( 'senderCarrierPopup' ) );

    if ( chosenCarrierId == INVALID_CARRIER_ID )
    {
        // Don't allow them to select a divider
        document.getElementById( 'senderCarrierPopup' ).options[ 0 ].selected = true;
    }
}


function FlipToFront( )
{
    var front = document.getElementById( "WIDGET_smsViewFrame" );
    var back = document.getElementById( "WIDGET_backViewFrame" );

    widget.prepareForTransition( "ToFront" );

    back.style.display = "none";
    front.style.display = "block";

    setTimeout( 'widget.performTransition( );', 0 );
}

function OnBackPaneDoneButton( )
{
    FlipToFront( );
}

/******************************************************************************
  OnCheckForUpdates

    Handler for back pane "Check for updates" button.

******************************************************************************/
function OnCheckForUpdates( )
{
    OpenWidgetURL( CLIENT_VERSION_CHECK_URL );
};

/******************************************************************************
  OnLogout

    "Help" button.

******************************************************************************/
function OnLogout( )
{
    FlipToFront( );
    SMS_widgetViewController.Logout( );
};
