
/******************************************************************************
  SMS_VerificationView c'tor

 ******************************************************************************/

function SMS_VerificationView( onVerificationSuccess, onLoginRequired )
{
    this.m_onVerificationSuccess = onVerificationSuccess;
    this.m_onLoginRequired       = onLoginRequired;
    this.m_carrierId = 0;
    // down-rev widgets has saved carrier id
    var savedCarrierId = VM_GetPreference( PREF_KEY_SENDER_CARRIER_ID );
    if ( typeof savedCarrierId != 'undefined' )
    {
        this.m_carrierId = parseInt( savedCarrierId );
    }
    this.m_hideRegCarrier = 0;
    this.m_fmtPhone = '';
    this.m_phoneCC = '';
    this.phoneNN = '';

    this.m_codeSent = false;

    function AddEditFieldMethod( self, identifier )
    {
        eval( 'self.Set' + identifier + 'Data = function( message ) ' +
              '{'                                                     +
                  'document.getElementById( "WIDGET_verification' + identifier + 'TextArea" ).value = message;' +
              '};'
            );

        eval( 'self.Get' + identifier + 'Data = function( ) '   +
              '{'                                               +
                  'return document.getElementById( "WIDGET_verification' + identifier + 'TextArea" ).value;' +
              '};'
            );

        eval( 'self.Get' + identifier + 'Obj = function( ) '    +
              '{'                                               +
                  'return document.getElementById( "WIDGET_verification' + identifier + 'TextArea" );' +
              '};'
            );
    }

    AddEditFieldMethod( this, 'Code' );
    // set up some closures
    var self = this;
    var onSetCarrierInfoSucceeded = function( responseMessage )
    {
        self.OnSetCarrierInfoSucceeded( responseMessage );
    };

    var onSetCarrierInfoFailed = function( statusMessage )
    {
        self.OnSetCarrierInfoFailed( statusMessage );
    };

    var onVerifyPhoneSucceeded = function( responseMessage )
    {
        self.OnVerifyPhoneSucceeded( responseMessage );
    };

    var onVerifyPhoneFailed = function( statusMessage )
    {
        self.OnVerifyPhoneFailed( statusMessage );
    };

    this.m_activationHandler = new ACT_ActivationHandler( VM_WIDGET_SOURCE,
                                                          VM_WIDGET_VERSION,
                                                          VM_WIDGET_OS_VERSION,
                                                          onSetCarrierInfoSucceeded,
                                                          onSetCarrierInfoFailed,
                                                          onVerifyPhoneSucceeded,
                                                          onVerifyPhoneFailed );

}
SMS_VerificationView.prototype =
{
    ERROR_MSG_COLOR                     : '#bf0000',
    DEFAULT_VERIFICATION_ERROR_MESSAGE  : 'Verification failed. Please try again later.',
    CODE_SEND_IN_PROGRESS_MESSAGE       : 'Sending...',
    CODE_SEND_COMPLETE_MESSAGE          : 'Sending...code sent.',


    /**************************************************************************
      Accessor and modify methods
     **************************************************************************/

    SetStatusText : function ( message, color )
    {
        try
        {
            UTILS.SetInnerHTML( 'WIDGET_verificationViewStatusTextArea', message, color );
        }
        catch ( e )
        {
            EX_ASSERT_NO_EXCEPTIONS( e, "SMS_VerificationView::SetStatusText( )" );
        }
    },

    /**************************************************************************
      View repainting methods
     **************************************************************************/

    reset:function( )
    {
        try
        {
            document.getElementById( 'WIDGET_verificationViewFrame' ).style.display = 'none';
            this.SetStatusText( '' );
            this.SetCodeData( '' );

            this.m_activationHandler.StopAllRequests( );
        }
        catch ( e )
        {
            EX_ASSERT_NO_EXCEPTIONS( e, "SMS_VerificationView::reset( )" );
        }
    },

    refresh:function( )
    {
        try
        {
            var stepNumber = 1;

            // show carrier popup for NANP users
            if ( this.m_phoneCC == '1' && this.m_hideRegCarrier == 0 )
            {
                document.getElementById( 'WIDGET_senderCarrier' ).style.display = 'block';
                SMS_UTILS_SelectItemInCustomPopup( this.m_carrierId, document.getElementById( 'WIDGET_wirelessProviderPopup' ), document.getElementById( 'WIDGET_carrierName' ) );

                stepNumber++;
            }
            else
            {
                document.getElementById( 'WIDGET_senderCarrier' ).style.display = 'none';
            }

            var message = stepNumber  + '. Check your mobile phone ' + this.m_fmtPhone + ' for a text message from CallWave with your verification code.<br /><br />';
            message += ++stepNumber + '. Enter the verification code here:<br />';

            document.getElementById( 'WIDGET_verificationMsg' ).innerHTML = message;
            document.getElementById( 'WIDGET_verificationViewFrame' ).style.display = 'block';
        }
        catch( e )
        {
            EX_Log( 'SMS_VerificationView::refresh( ).' + e.message );
        }
    },

    OnLoginSucceeded : function( carrierId, hideRegCarrier, fmtPhone, phoneCC, phoneNN )
    {
        try
        {
            this.m_carrierId = carrierId;
            this.m_hideRegCarrier = hideRegCarrier;
            this.m_fmtPhone = fmtPhone;
            this.m_phoneCC = phoneCC;
            this.m_phoneNN = phoneNN;
        }
        catch ( e )
        {
            EX_ASSERT_NO_EXCEPTIONS( e, 'SMS_VerificationView::OnLoginSucceeded( )' );
        }
    },

    OnWirelessProviderSelected : function( elem )
    {
        try
        {
            var chosenCarrierId = elem.options[ elem.selectedIndex ].value;
            if ( chosenCarrierId == INVALID_CARRIER_ID )
            {
                SMS_UTILS_SelectFirstItemInCustomPopup( elem, document.getElementById( "WIDGET_carrierName" ) );
                return;
            }
            var chosenCarrier = elem.options[ elem.selectedIndex ].text;
            document.getElementById( "WIDGET_carrierName" ).innerText = chosenCarrier;
            this.m_carrierId = chosenCarrierId;
            this.SendCarrierInfo( );
        }
        catch ( e )
        {
            EX_Log( "SMS_VerificationView::OnWirelessProviderSelected( ) : " + e.message );
        }
    },

    /**************************************************************************
      Activation methods
     **************************************************************************/

    SendCarrierInfo:function( )
    {
        try
        {
            if ( this.m_activationHandler.IsSetCarrierInfoRequestInProgress( ) )
            {
                // ignore
                return;
            }

            this.SetStatusText( this.CODE_SEND_IN_PROGRESS_MESSAGE );

            this.m_activationHandler.setCarrierInfo( VM_GetPreference( PREF_KEY_ACCOUNT ),
                                                     VM_GetPreference( PREF_KEY_U_STRING ),
                                                     this.m_carrierId );
        }
        catch ( e )
        {
            EX_ASSERT_NO_EXCEPTIONS( e, 'SMS_VerificationView::SendCarrierInfo( )' );
        }
    },

    OnSetCarrierInfoSucceeded: function( responseMessage )
    {
        try
        {
            this.m_codeSent = true;

            switch ( responseMessage.m_status )
            {
            case 0:
                {
                    this.SetStatusText( this.CODE_SEND_COMPLETE_MESSAGE );
                    break;
                }

            case 11:
                {
                    this.m_onLoginRequired( responseMessage.m_statusMsg );
                    break;
                }

            case 2:
            default:
                {
                    var alertMessage = "Sorry, failed to update your account due to a server error. Please try again later.";

                    if ( responseMessage.m_statusMsg != null && responseMessage.m_statusMsg.length != 0 )
                    {
                        alertMessage = responseMessage.m_statusMsg;
                    }

                    this.SetStatusText( alertMessage, this.ERROR_MSG_COLOR );

                    break;
                }
            }
        }
        catch ( e )
        {
            EX_Log( "SMS_VerificationView::OnSetCarrierInfoSucceeded( ) : " + e.message ? e.message : UTILS.dump(e) );
        }
    },

    OnSetCarrierInfoFailed: function( statusMessage )
    {
        try
        {
            this.m_codeSent = true;

            this.SetStatusText(
                    "Sorry, failed to receive your carrier due to a server error. Please try again later.", this.ERROR_MSG_COLOR );

            EX_Log( "SMS_VerificationView::OnSetCarrierInfoFailed( ) : " + statusMessage );
        }
        catch ( e )
        {
            EX_Log( "SMS_VerificationView::OnSetCarrierInfoFailed( ) : " + e.message );
        }
    },

    HandleVerifySubmit:function( )
    {
        try
        {
            this.SetStatusText( '' );

            var verificationCode = this.GetCodeData( );

            // verification code is 'V' followed by 6 digits
            verificationCode = verificationCode.toUpperCase( );

            // be forgiving to missing 'V'
            if ( verificationCode.charAt(0) != 'V' )
            {
                verificationCode = 'V' + verificationCode;
            }
            var validatedCode = verificationCode.match( /^[V]\d\d\d\d\d\d/ );

            if ( validatedCode == null ||
                 validatedCode.length == 0 ||
                ( validatedCode[0].length != 7 ) )
            {
                this.SetStatusText( 'Invalid code. Your verification code is 6 digits.', this.ERROR_MSG_COLOR );
                return;
            }

            this.VerifyPhone( verificationCode );
        }
        catch ( e )
        {
            this.SetStatusText( this.DEFAULT_VERIFICATION_ERROR_MESSAGE, this.ERROR_MSG_COLOR );

            EX_Log( "SMS_VerificationView::HandleSubmit( ) : " + e.message );
        }
    },

    VerifyPhone:function( verificationCode )
    {
        try
        {
            if ( this.m_activationHandler.IsVerifyPhoneRequestInProgress( ) )
            {
                // ignore
                return;
            }

            if ( this.m_codeSent )
            {
                this.SetStatusText( this.CODE_SEND_IN_PROGRESS_MESSAGE );
            }

            this.m_activationHandler.verifyPhone( VM_GetPreference( PREF_KEY_ACCOUNT ),
                                                  VM_GetPreference( PREF_KEY_U_STRING ),
                                                  verificationCode,
                                                  this.m_phoneCC,
                                                  this.m_phoneNN );
        }
        catch ( e )
        {
            this.SetStatusText( this.DEFAULT_VERIFICATION_ERROR_MESSAGE, this.ERROR_MSG_COLOR );

            EX_Log( "SMS_VerificationView::VerifyPhone( ) : " + e.message );
        }
    },

    OnVerifyPhoneSucceeded:function( responseMessage )
    {
        try
        {
            var initialCodeSend = ! this.m_codeSent;

            this.m_codeSent = true;

            switch ( responseMessage.m_status )
            {
            case MSG_ResponseStatus.SUCCESS:
                {
                    if ( ! initialCodeSend )
                    {
                        this.SetStatusText( this.CODE_SEND_COMPLETE_MESSAGE );
                    }

                    if ( responseMessage.m_successCase == 1 )
                    {
                        this.m_onVerificationSuccess( );
                    }
                    break;
                }
            case MSG_ResponseStatus.GENERAL_ERROR:
                {
                    this.SetStatusText( responseMessage.m_statusMsg, this.ERROR_MSG_COLOR );
                    break;
                }

            case MSG_ResponseStatus.VPHO_LOGIN_FAILURE:
            case MSG_ResponseStatus.VPHO_COUNTRY_NOT_SUPPORTED:
                {
                    this.m_onLoginRequired( responseMessage.m_statusMsg, this.ERROR_MSG_COLOR );
                }
                break;

            default:
                {
                    var alertMessage = "Sorry, failed to update your account due to a server error. Please try again later.";

                    if ( responseMessage.m_statusMsg != null && responseMessage.m_statusMsg.length != 0 )
                    {
                        alertMessage = responseMessage.m_statusMsg;
                    }

                    this.SetStatusText( alertMessage, this.ERROR_MSG_COLOR );

                    break;
                }
            }
        }
        catch ( e )
        {
            this.SetStatusText( this.DEFAULT_VERIFICATION_ERROR_MESSAGE, this.ERROR_MSG_COLOR );

            EX_Log( "SMS_VerificationView::OnVerificationSucceeded( ) : " + e.message );
        }
    },

    OnVerifyPhoneFailed:function( statusMessage )
    {
        try
        {
            this.m_codeSent = true;

            this.SetStatusText( this.DEFAULT_VERIFICATION_ERROR_MESSAGE, this.ERROR_MSG_COLOR );

            EX_Log( "SMS_VerificationView::onVerificationFailed( ) : " + statusMessage );
        }
        catch ( e )
        {
            EX_Log( "SMS_VerificationView::onVerificationFailed( ) : " + e.message );
        }
    }
}
